﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.Rtc.Sip;
using System.Windows.Forms;

namespace Work
{
    class TestWork
    {
        static public Boolean ServiceRun = true;
        static public ServerAgent agent = null;
        public class Application
        {
            string ProcessMessage(string content)
            {
                string newContent = content;
                RichTextBox rtBox = new RichTextBox();
                //rtBox.Text - собственно тут будет сохранен текст сообщения, 
                //с которым можно работать, но после обработки, его надо 
                //вернуть Lync Server в формате RTF, 
                //по этому можно сделать например так:
                //rtBox.Clear();
                //rtBox.Text = новый текст
                newContent = rtBox.Rtf;
                return newContent;
            }

            public void OnRequest(object sender, RequestReceivedEventArgs e)
            {                
                e.Request.SimpleProxy = true;
                e.ServerTransaction.EnableForking = false;
                e.Request.Content = ProcessMessage(e.Request.Content);                
                e.ServerTransaction.CreateBranch().SendRequest(e.Request);
            }

            public void OnResponse(object sender, ResponseReceivedEventArgs e)
            {
                e.Response.Content = ProcessMessage(e.Response.Content);
                e.ClientTransaction.ServerTransaction.SendResponse(e.Response);
            }

            public void Runner()
            {
                while (ServiceRun)
                {                    
                    agent.WaitHandle.WaitOne();
                    // запускаем каждый обработчик в отдельном потоке
                    ThreadPool.QueueUserWorkItem(new WaitCallback(agent.ProcessEvent)); 
                }
            }
        }


        public void Start()
        {
            // поступила коданда старта сервиса
            Application serverApplication = new Application();
            // ожидание готовности сервера Lync
            ServerAgent.WaitForServerAvailable(5); // 5 times
            // загружаем манифест решения
            ApplicationManifest manifest = ApplicationManifest.CreateFromFile("Manifest.am");
            // и компилируем его
            manifest.Compile();
            agent = new ServerAgent(serverApplication, manifest);
            if (agent != null)
            {
                ServiceRun = true;
                Thread myThread = new Thread(serverApplication.Runner); 
                myThread.Start(); //запускаем основной поток
            }
        }

        public void Stop()
        {
            // поступила коданда остановки сервиса
            ServiceRun = false;
        }
    }
}
